<?php
//error_reporting(E_ALL);
// no direct access
defined("_JEXEC") or die("Restricted access");
if (!defined('DS')) {
  define('DS',DIRECTORY_SEPARATOR);
}
if (!class_exists('Facebook', false)) {
  require_once (JPATH_ROOT.DS.'plugins'.DS.'content'.DS.'fb_tw_plus1'.DS.'facebook'.DS.'facebook.php');
}

jimport('joomla.html.html');
jimport('joomla.form.formfield');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.form.helper');

class JFormFieldfbextraparams extends JFormField {
  protected $type = "fbextraparams";
  
  private function getHTLMtextfield($label,$value,$name){
    $html = array();
    $html[] = '<div class="control-group">';
    $html[] = ' <div class="control-label">'.$label.'</div>';
    $html[] = ' <div class="controls">';
    $html[] = '  <input type="text"     name="'.$this->name.$name.'" value="'.$value.'" size="50" />';
    $html[] = ' </div>';
    $html[] = '</div>';
    $code=implode($html);
    return $code;
  }
  
  private function getHTLMcheckboxfield($label,$value,$name,$checked){
    $html = array();
    $html[] = '<div class="control-group">';
    $html[] = ' <div class="control-label">' . $label . '</div>';
    $html[] = ' <div class="controls">';
    $html[] = '  <input type="checkbox" name="'.$this->name.$name.'" value="'.$value.'" '.$checked.' />';
    $html[] = ' </div>';
    $html[] = '</div>';
    $code=implode($html);
    return $code;
  }
  
  private function getHTLMmsgfield($text,$class){
    $class = !empty($class) ? ' class="' . $class . '"' : '';
    $html = array();
    $html[] = '<div class="control-group">';
    $html[] = ' <span class="spacer">';
    $html[] = '  <span class="before"></span>';
    $html[] = '  <span '.$class.'>';
    $html[] = '   <label id="' . $this->id . '-lbl" class="hasTooltip"><b>' . $text . '</b></label>';
    $html[] = '  </span>';
    $html[] = '  <span class="after"></span>';
    $html[] = ' </span>';
    $html[] = '</div>';
    $code=implode($html);
    return $code;
  }
  
  public function getControlGroup(){
    $cache = JFactory::getCache('');
    $nocache = true;
    if (JPluginHelper::isEnabled('system', 'cache')) {
      $nocache = false;
    } else {
      if (isset($cache->options)) {
        if ($cache->options['caching'])
          $nocache = false;
      } else {
        if ($cache->_options['caching'])
          $nocache = false;
      }
    }
    if (!$nocache) JFactory::getApplication()->enqueueMessage('Cache is enabled in this site!<br>To avoid problems please disable it.','error');
  
    $fbparams      = $this->form->getValue('params');
    $fb_enable_autopublish = $fbparams->fb_enable_autopublish;
    if ($fb_enable_autopublish=='0') return '';
    $fb_app_id     = $fbparams->fb_app_id;
    $fb_secret_key = $fbparams->fb_secret_key;
    $fb_token      = (isset($fbparams->fb_extra_params))?$fbparams->fb_extra_params['fb_token']:'';
    $fb_admin      = (isset($fbparams->fb_extra_params))?$fbparams->fb_extra_params['fb_admin']:'';
    if (!isset($fbparams->fb_extra_params) || $fbparams->fb_extra_params['fb_ids']=='') {
      $fb_ids      = array();
    } else {
      $fb_ids      = $fbparams->fb_extra_params['fb_ids'];
    }
  
    $html = array();
  
    if (($fb_app_id != '') && ($fb_secret_key != '')) {
  
      $facebook = new Facebook(array('appId' => $fb_app_id, 'secret' => $fb_secret_key));
      $user = $facebook->getUser();
  
      $uri= JFactory::getURI();
      $url=urlencode($uri->current().'?'.$uri->getQuery());
      $loginUrl = "https://www.facebook.com/dialog/oauth?client_id=".$fb_app_id."&redirect_uri=".$url."&scope=publish_stream,publish_actions,offline_access,manage_pages,user_groups";
  
      if ($fb_token != '') { //if there is a token => check the token
        $facebook->setAccessToken($fb_token);
        try {
          $user=$facebook->api('/me');
        } catch (Exception $e) {
          //Access token is not valid
          $user=null;
        }
      } else {
        //Access token missing
        $user=null;
      }
  
      if ($user) { //access token ok
        $fb_admin = $user['id'];
        $html[] = $this->getHTLMtextfield('Access Token'    ,$fb_token,'[fb_token]');
        $html[] = $this->getHTLMtextfield('Administrator ID',$fb_admin,'[fb_admin]');
        if (count($fb_ids)==0) {
          $html[] = $this->getHTLMmsgfield('Choose the walls account,groups or pages where to publish','fb_message');
        }
        $html[] = $this->getHTLMmsgfield('Admin account','');
        $html[] = $this->getHTLMcheckboxfield('Wall ID::Administrator ID',$fb_admin,'[fb_ids][]',(in_array($fb_admin, $fb_ids) ? " checked='checked'" : ""));
  
        try {
          $groups = $facebook->api('/'.$fb_admin.'/groups/','GET', array('access_token' => $fb_token));
        } catch (FacebookApiException $e) {
          $this->show($e);
          $groups = null;
        }
        if ($groups && $groups['data'] && is_array($groups['data']) && count($groups['data']) > 0) {
          $html[] = $this->getHTLMmsgfield('Groups','');
          foreach($groups['data'] as $group) {
            $html[] = $this->getHTLMcheckboxfield($group['name'],$group['id'],'[fb_ids][]',(in_array($group['id'], $fb_ids) ? " checked='checked'" : ""));
          }
        }
  
        try {
          $pages = $facebook->api('/'.$fb_admin.'/accounts/', 'GET', array('access_token' => $fb_token));
        } catch (FacebookApiException $e) {
          $this->show($e);
          $pages = null;
        }
        if ($pages && $pages['data'] && is_array($pages['data']) && count($pages['data']) > 0) {
          $html[] = $this->getHTLMmsgfield('Pages','');
          foreach($pages['data'] as $page) {
            if ($page['category'] != 'Application') {
              $html[] = $this->getHTLMcheckboxfield($page['name'],$page['id'],'[fb_ids][]',(in_array($page['id'], $fb_ids) ? " checked='checked'" : ""));
            }
          }
        }
      } else { //if access token is not valid or missing
        $code = JRequest::getVar('code');
        if ($code && !empty($code)) {
          $uri= JFactory::getURI();
          $url=urlencode($uri->current().'?'.$uri->getQuery());
          $token_url = "https://graph.facebook.com/oauth/access_token?client_id=".$fb_app_id."&redirect_uri=".$url."&client_secret=".$fb_secret_key."&code=".$code;
          $response = $this->get_url_contents($token_url);
          if (empty($response)||preg_match('/error/i',$response)){
            JFactory::getApplication()->enqueueMessage( 'Error on access token:<pre>'.$response.'</pre>', 'error' );
          } else {
            $params = null;
            parse_str($response, $params);
            $fb_token = $params['access_token'];
          }
          $html[] = $this->getHTLMtextfield('Access Token',$fb_token,'[fb_token]');
          $html[] = '<input type="hidden" name="'.$this->name.'[fb_admin]" value="" />';
          $html[] = '<input type="hidden" name="'.$this->name.'[fb_ids]" value="" />';
          $html[] = $this->getHTLMmsgfield('Save to complete the configuration of the Facebook Application','fb_message');
        } else {
          $fb_token='';
          $fb_admin='';
          $html[] = '<input type="hidden" name="'.$this->name.'[fb_token]" value="" />';
          $html[] = '<input type="hidden" name="'.$this->name.'[fb_admin]" value="" />';
          $html[] = '<input type="hidden" name="'.$this->name.'[fb_ids]" value="" />';
          $html[] = $this->getHTLMmsgfield('Click the link to connect the Facebook Application <a class="fb_button" href="'.$loginUrl.'" title="Facebook login">Facebook login</a>','fb_message');
        }
      }
    } else {
      $fb_token='';
      $fb_admin='';
      $html[] = '<input type="hidden" name="'.$this->name.'[fb_token]" value="" />';
      $html[] = '<input type="hidden" name="'.$this->name.'[fb_admin]" value="" />';
      $html[] = '<input type="hidden" name="'.$this->name.'[fb_ids]" value="" />';
    }
    $html[] = '<style>.fb_message {border: 2px solid #a00;background-color: #FAF2EA;padding: 10px;margin: 5px;display: inline-block;}</style>';
  
    $code=implode($html);
    return $code;
  }
  
  private function get_url_contents($url){
    $ch = curl_init();
    $timeout = 5;
    curl_setopt ($ch, CURLOPT_URL,$url);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    $ret = curl_exec($ch);
    curl_close($ch);
    return $ret;
  }
  
  private function Show($var, $mode = 'message'){
    JFactory::getApplication()->enqueueMessage('<pre>' . print_r($var,true) . '</pre>',$mode);
  }
}

?>